import 'package:jaguar_retrofit/annotations/annotations.dart';
import 'package:jaguar_retrofit/jaguar_retrofit.dart';
import 'package:jaguar_serializer/jaguar_serializer.dart';
import 'package:jaguar_mimetype/jaguar_mimetype.dart';
import 'dart:async';

import 'package:pointpos_api/model/exception.dart';
import 'package:pointpos_api/model/reports_sales.dart';

part 'reports_api.jretro.dart';

@GenApiClient()
class ReportsApi extends ApiClient with _$ReportsApiClient {
    final Route base;
    final Map<String, CodecRepo> converters;
    final Duration timeout;

    ReportsApi({this.base, this.converters, this.timeout = const Duration(minutes: 2)});

    /// Get Reports Sales Summary
    ///
    /// Get Reports Sales Summary
    @GetReq(path: "/reports/:grouping", metadata: {"auth": [ {"type": "apiKey", "name": "JWT", "keyName": "Authorization", "where": "header" }]})
    Future<ReportsSales> getReportsSales(
            @PathParam("grouping") String grouping
        ,
            @Header("Authorization") String authorization, 
        
            @Header("X-API-Key") String xAPIKey
        ,
            @QueryParam("filter") List<String> filter
        ) {
        return super.getReportsSales(
        grouping
        ,
        authorization, 
        
        xAPIKey
        ,
        filter

        ).timeout(timeout);
    }


}
